/*
Copyright (C) 1992-1994 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "wolfdef.h"

state_t states[NUMSTATES] = {
{S_GUARD_WLK4, 0, T_STAND, A_NULL, ST_GRD_STND},
{S_GUARD_WLK1,12, T_CHASE, A_TARGET, ST_GRD_WLK2},
{S_GUARD_WLK2,12, T_CHASE, A_TARGET, ST_GRD_WLK3},
{S_GUARD_WLK3,12, T_CHASE, A_TARGET, ST_GRD_WLK4},
{S_GUARD_WLK4,12, T_CHASE, A_TARGET, ST_GRD_WLK1},
{S_GUARD_ATK1,16, T_NULL, A_NULL, ST_GRD_ATK2},
{S_GUARD_ATK2,16, T_NULL, A_NULL, ST_GRD_ATK3},
{S_GUARD_ATK3,16, T_NULL, A_SHOOT, ST_GRD_WLK1},
{S_GUARD_PAIN,12, T_NULL, A_NULL, ST_GRD_WLK1},
{S_GUARD_PAIN, 8, T_NULL, A_NULL, ST_GRD_DTH1},
{S_GUARD_DTH1, 8, T_NULL, A_SCREAM, ST_GRD_DTH2},
{S_GUARD_DTH2, 8, T_NULL, A_THUD, ST_GRD_DTH3},
{S_GUARD_DTH3, 0, T_NULL, A_NULL, ST_GRD_DTH3},
{S_DOG_WLK4, 0, T_STAND, A_NULL, ST_DOG_STND},
{S_DOG_WLK1, 8, T_CHASE, A_TARGET, ST_DOG_WLK2},
{S_DOG_WLK2, 8, T_CHASE, A_TARGET, ST_DOG_WLK3},
{S_DOG_WLK3, 8, T_CHASE, A_TARGET, ST_DOG_WLK4},
{S_DOG_WLK4, 8, T_CHASE, A_TARGET, ST_DOG_WLK1},
{S_DOG_ATK1, 8, T_NULL, A_NULL, ST_DOG_ATK2},
{S_DOG_ATK2, 8, T_NULL, A_NULL, ST_DOG_ATK3},
{S_DOG_ATK3,20, T_NULL, A_BITE, ST_DOG_ATK4},
{S_DOG_WLK1, 8, T_NULL, A_NULL, ST_DOG_WLK1},
{S_DOG_DTH1, 8, T_NULL, A_NULL, ST_DOG_DTH2},
{S_DOG_DTH2, 8, T_NULL, A_SCREAM, ST_DOG_DTH3},
{S_DOG_DTH3, 8, T_NULL, A_THUD, ST_DOG_DTH4},
{S_DOG_DTH3, 0, T_NULL, A_NULL, ST_DOG_DTH4},
{S_SS_WLK4, 0, T_STAND, A_NULL, ST_SS_STND},
{S_SS_WLK1,20, T_CHASE, A_TARGET, ST_SS_WLK2},
{S_SS_WLK2,20, T_CHASE, A_TARGET, ST_SS_WLK3},
{S_SS_WLK3,20, T_CHASE, A_TARGET, ST_SS_WLK4},
{S_SS_WLK4,20, T_CHASE, A_TARGET, ST_SS_WLK1},
{S_SS_ATK1,20, T_NULL, A_NULL, ST_SS_ATK2},
{S_SS_ATK2,20, T_NULL, A_NULL, ST_SS_ATK3},
{S_SS_ATK3, 8, T_NULL, A_SHOOT, ST_SS_ATK4},
{S_SS_ATK2, 8, T_NULL, A_NULL, ST_SS_ATK5},
{S_SS_ATK3, 8, T_NULL, A_SHOOT, ST_SS_ATK6},
{S_SS_ATK2, 8, T_NULL, A_NULL, ST_SS_ATK7},
{S_SS_ATK3, 8, T_NULL, A_SHOOT, ST_SS_ATK8},
{S_SS_ATK2, 8, T_NULL, A_NULL, ST_SS_ATK9},
{S_SS_ATK3, 8, T_NULL, A_SHOOT, ST_SS_WLK1},
{S_SS_PAIN, 8, T_NULL, A_NULL, ST_SS_WLK1},
{S_SS_PAIN, 8, T_NULL, A_NULL, ST_SS_DTH1},
{S_SS_DTH1, 8, T_NULL, A_SCREAM, ST_SS_DTH2},
{S_SS_DTH2, 8, T_NULL, A_THUD, ST_SS_DTH3},
{S_SS_DTH3, 0, T_NULL, A_NULL, ST_SS_DTH3},
{S_OFFICER_WLK4, 0, T_STAND, A_NULL, ST_OFC_STND},
{S_OFFICER_WLK1,12, T_CHASE, A_TARGET, ST_OFC_WLK2},
{S_OFFICER_WLK2, 8, T_CHASE, A_TARGET, ST_OFC_WLK3},
{S_OFFICER_WLK3,12, T_CHASE, A_TARGET, ST_OFC_WLK4},
{S_OFFICER_WLK4, 8, T_CHASE, A_TARGET, ST_OFC_WLK1},
{S_OFFICER_ATK1, 8, T_NULL, A_NULL, ST_OFC_ATK2},
{S_OFFICER_ATK2, 8, T_NULL, A_NULL, ST_OFC_ATK3},
{S_OFFICER_ATK3,16, T_NULL, A_SHOOT, ST_OFC_WLK1},
{S_OFFICER_PAIN, 8, T_NULL, A_NULL, ST_OFC_WLK1},
{S_OFFICER_PAIN, 8, T_NULL, A_NULL, ST_OFC_DTH1},
{S_OFFICER_DTH1, 8, T_NULL, A_SCREAM, ST_OFC_DTH2},
{S_OFFICER_DTH2, 8, T_NULL, A_THUD, ST_OFC_DTH3},
{S_OFFICER_DTH3, 0, T_NULL, A_NULL, ST_OFC_DTH3},
{S_MUTANT_WLK4, 0, T_STAND, A_NULL, ST_MUTANT_STND},
{S_MUTANT_WLK1,16, T_CHASE, A_TARGET, ST_MUTANT_WLK2},
{S_MUTANT_WLK2,16, T_CHASE, A_TARGET, ST_MUTANT_WLK3},
{S_MUTANT_WLK3,16, T_CHASE, A_TARGET, ST_MUTANT_WLK4},
{S_MUTANT_WLK4,16, T_CHASE, A_TARGET, ST_MUTANT_WLK1},
{S_MUTANT_ATK1, 8, T_NULL, A_NULL, ST_MUTANT_ATK2},
{S_MUTANT_ATK2,20, T_NULL, A_SHOOT, ST_MUTANT_ATK3},
{S_MUTANT_ATK1, 8, T_NULL, A_NULL, ST_MUTANT_ATK4},
{S_MUTANT_ATK3,20, T_NULL, A_SHOOT, ST_MUTANT_WLK1},
{S_MUTANT_PAIN, 8, T_NULL, A_NULL, ST_MUTANT_WLK1},
{S_MUTANT_PAIN, 8, T_NULL, A_NULL, ST_MUTANT_DTH1},
{S_MUTANT_DTH1, 8, T_NULL, A_SCREAM, ST_MUTANT_DTH2},
{S_MUTANT_DTH2, 8, T_NULL, A_THUD, ST_MUTANT_DTH3},
{S_MUTANT_DTH3, 0, T_NULL, A_NULL, ST_MUTANT_DTH3},
{S_HANS_WLK4, 0, T_STAND, A_NULL, ST_HANS_STND},
{S_HANS_WLK1,20, T_CHASE, A_TARGET, ST_HANS_WLK2},
{S_HANS_WLK2,20, T_CHASE, A_TARGET, ST_HANS_WLK3},
{S_HANS_WLK3,20, T_CHASE, A_TARGET, ST_HANS_WLK4},
{S_HANS_WLK4,20, T_CHASE, A_TARGET, ST_HANS_WLK1},
{S_HANS_ATK1,40, T_NULL, A_NULL, ST_HANS_ATK2},
{S_HANS_ATK2,12, T_NULL, A_SHOOT, ST_HANS_ATK3},
{S_HANS_ATK3,12, T_NULL, A_SHOOT, ST_HANS_ATK4},
{S_HANS_ATK2,12, T_NULL, A_SHOOT, ST_HANS_ATK5},
{S_HANS_ATK3,12, T_NULL, A_SHOOT, ST_HANS_ATK6},
{S_HANS_ATK2,12, T_NULL, A_SHOOT, ST_HANS_ATK7},
{S_HANS_ATK3,12, T_NULL, A_SHOOT, ST_HANS_WLK1},
{S_HANS_DTH1,16, T_NULL, A_SCREAM, ST_HANS_DTH2},
{S_HANS_DTH2,16, T_NULL, A_THUD, ST_HANS_DTH3},
{S_HANS_DTH3, 0, T_NULL, A_NULL, ST_HANS_DTH3},
{S_SCHABBS_WLK4, 0, T_STAND, A_NULL, ST_SCHABBS_STND},
{S_SCHABBS_WLK1,20, T_CHASE, A_TARGET, ST_SCHABBS_WLK2},
{S_SCHABBS_WLK2,20, T_CHASE, A_TARGET, ST_SCHABBS_WLK3},
{S_SCHABBS_WLK3,20, T_CHASE, A_TARGET, ST_SCHABBS_WLK4},
{S_SCHABBS_WLK4,20, T_CHASE, A_TARGET, ST_SCHABBS_WLK1},
{S_SCHABBS_ATK1,28, T_NULL, A_NULL, ST_SCHABBS_ATK2},
{S_SCHABBS_ATK2,12, T_NULL, A_THROW, ST_SCHABBS_WLK1},
{S_SCHABBS_DTH1,16, T_NULL, A_SCREAM, ST_SCHABBS_DTH2},
{S_SCHABBS_DTH2,16, T_NULL, A_THUD, ST_SCHABBS_DTH3},
{S_SCHABBS_DTH3, 0, T_NULL, A_NULL, ST_SCHABBS_DTH3},
{S_TRANS_WLK4, 0, T_STAND, A_NULL, ST_TRANS_STND},
{S_TRANS_WLK1,20, T_CHASE, A_TARGET, ST_TRANS_WLK2},
{S_TRANS_WLK2,20, T_CHASE, A_TARGET, ST_TRANS_WLK3},
{S_TRANS_WLK3,20, T_CHASE, A_TARGET, ST_TRANS_WLK4},
{S_TRANS_WLK4,20, T_CHASE, A_TARGET, ST_TRANS_WLK1},
{S_TRANS_ATK1,48, T_NULL, A_NULL, ST_TRANS_ATK2},
{S_TRANS_ATK2,12, T_NULL, A_SHOOT, ST_TRANS_ATK3},
{S_TRANS_ATK3,12, T_NULL, A_SHOOT, ST_TRANS_ATK4},
{S_TRANS_ATK2,12, T_NULL, A_SHOOT, ST_TRANS_ATK5},
{S_TRANS_ATK3,12, T_NULL, A_SHOOT, ST_TRANS_ATK6},
{S_TRANS_ATK2,12, T_NULL, A_SHOOT, ST_TRANS_ATK7},
{S_TRANS_ATK3,12, T_NULL, A_SHOOT, ST_TRANS_WLK1},
{S_TRANS_DTH1,16, T_NULL, A_SCREAM, ST_TRANS_DTH2},
{S_TRANS_DTH2,16, T_NULL, A_THUD, ST_TRANS_DTH3},
{S_TRANS_DTH3, 0, T_NULL, A_NULL, ST_TRANS_DTH3},
{S_UBER_WLK4, 0, T_STAND, A_NULL, ST_UBER_STND},
{S_UBER_WLK1,12, T_CHASE, A_TARGET, ST_UBER_WLK2},
{S_UBER_WLK2,12, T_CHASE, A_TARGET, ST_UBER_WLK3},
{S_UBER_WLK3,12, T_CHASE, A_TARGET, ST_UBER_WLK4},
{S_UBER_WLK4,12, T_CHASE, A_TARGET, ST_UBER_WLK1},
{S_UBER_ATK1,40, T_NULL, A_NULL, ST_UBER_ATK2},
{S_UBER_ATK2, 8, T_NULL, A_SHOOT, ST_UBER_ATK3},
{S_UBER_ATK3, 8, T_NULL, A_SHOOT, ST_UBER_ATK4},
{S_UBER_ATK2, 8, T_NULL, A_SHOOT, ST_UBER_ATK5},
{S_UBER_ATK3, 8, T_NULL, A_SHOOT, ST_UBER_ATK6},
{S_UBER_ATK2, 8, T_NULL, A_SHOOT, ST_UBER_ATK7},
{S_UBER_ATK3, 8, T_NULL, A_SHOOT, ST_UBER_WLK1},
{S_UBER_DTH1,16, T_NULL, A_SCREAM, ST_UBER_DTH2},
{S_UBER_DTH2,16, T_NULL, A_THUD, ST_UBER_DTH3},
{S_UBER_DTH3, 0, T_NULL, A_NULL, ST_UBER_DTH3},
{S_DKNIGHT_WLK4, 0, T_STAND, A_NULL, ST_DKNIGHT_STND},
{S_DKNIGHT_WLK1,20, T_CHASE, A_TARGET, ST_DKNIGHT_WLK2},
{S_DKNIGHT_WLK2,20, T_CHASE, A_TARGET, ST_DKNIGHT_WLK3},
{S_DKNIGHT_WLK3,20, T_CHASE, A_TARGET, ST_DKNIGHT_WLK4},
{S_DKNIGHT_WLK4,20, T_CHASE, A_TARGET, ST_DKNIGHT_WLK1},
{S_DKNIGHT_ATK1,28, T_NULL, A_NULL, ST_DKNIGHT_ATK2},
{S_DKNIGHT_ATK2,12, T_NULL, A_LAUNCH, ST_DKNIGHT_ATK3},
{S_DKNIGHT_ATK4,12, T_NULL, A_SHOOT, ST_DKNIGHT_ATK4},
{S_DKNIGHT_ATK3,12, T_NULL, A_LAUNCH, ST_DKNIGHT_ATK5},
{S_DKNIGHT_ATK4,12, T_NULL, A_SHOOT, ST_DKNIGHT_WLK1},
{S_DKNIGHT_DTH1,16, T_NULL, A_SCREAM, ST_DKNIGHT_DTH2},
{S_DKNIGHT_DTH2,16, T_NULL, A_THUD, ST_DKNIGHT_DTH3},
{S_DKNIGHT_DTH3, 0, T_NULL, A_NULL, ST_DKNIGHT_DTH3},
{S_MHITLER_WLK4, 0, T_STAND, A_NULL, ST_MHITLER_STND},
{S_MHITLER_WLK1,20, T_CHASE, A_MECHSTEP, ST_MHITLER_WLK2},
{S_MHITLER_WLK2,20, T_CHASE, A_TARGET, ST_MHITLER_WLK3},
{S_MHITLER_WLK3,20, T_CHASE, A_MECHSTEP, ST_MHITLER_WLK4},
{S_MHITLER_WLK4,20, T_CHASE, A_TARGET, ST_MHITLER_WLK1},
{S_MHITLER_ATK1,28, T_NULL, A_NULL, ST_MHITLER_ATK2},
{S_MHITLER_ATK2, 8, T_NULL, A_SHOOT, ST_MHITLER_ATK3},
{S_MHITLER_ATK3, 8, T_NULL, A_SHOOT, ST_MHITLER_ATK4},
{S_MHITLER_ATK2, 8, T_NULL, A_SHOOT, ST_MHITLER_ATK5},
{S_MHITLER_ATK3, 8, T_NULL, A_SHOOT, ST_MHITLER_ATK6},
{S_MHITLER_ATK2, 8, T_NULL, A_SHOOT, ST_MHITLER_ATK7},
{S_MHITLER_ATK3, 8, T_NULL, A_SHOOT, ST_MHITLER_WLK1},
{S_MHITLER_DIE1,12, T_NULL, A_NULL, ST_MHITLER_DIE2},
{S_MHITLER_DIE2,12, T_NULL, A_NULL, ST_MHITLER_DIE3},
{S_MHITLER_DIE3,12, T_NULL, A_NULL, ST_MHITLER_DIE4},
{S_HITLER_WLK4, 8, T_NULL, A_HITLERMORPH, ST_HITLER_WLK1},
{S_HITLER_WLK1,12, T_CHASE, A_TARGET, ST_HITLER_WLK2},
{S_HITLER_WLK2, 8, T_CHASE, A_TARGET, ST_HITLER_WLK3},
{S_HITLER_WLK3,12, T_CHASE, A_TARGET, ST_HITLER_WLK4},
{S_HITLER_WLK4, 8, T_CHASE, A_TARGET, ST_HITLER_WLK1},
{S_HITLER_ATK1,28, T_NULL, A_NULL, ST_HITLER_ATK2},
{S_HITLER_ATK2, 8, T_NULL, A_SHOOT, ST_HITLER_ATK3},
{S_HITLER_ATK3, 8, T_NULL, A_SHOOT, ST_HITLER_ATK4},
{S_HITLER_ATK2, 8, T_NULL, A_SHOOT, ST_HITLER_ATK5},
{S_HITLER_ATK3, 8, T_NULL, A_SHOOT, ST_HITLER_WLK1},
{S_HITLER_DTH1,16, T_NULL, A_SCREAM, ST_HITLER_DTH2},
{S_HITLER_DTH2,16, T_NULL, A_NULL, ST_HITLER_DTH3},
{S_HITLER_DTH3,120,T_NULL, A_THUD, ST_HITLER_DTH4},
{S_HITLER_DTH3, 0, T_NULL, A_VICTORY, ST_HITLER_DTH4}
};
